using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace IKTestBed
{
    class Camera : GameComponent
    {
        public Vector3 Position;
        public Vector3 Target;
        public float NearClip;
        public float FarClip;
        public float FOV;

        public Matrix World, View, Projection;

        private Rectangle clientBounds;
        private float aspectRatio;
        

        public Camera(Game game)
            : base(game)
        {
            Position = new Vector3(5, 5, 30);
            Target = Vector3.Zero;// new Vector3(-30, 0, 0);
            clientBounds = game.Window.ClientBounds;
            aspectRatio = (float)clientBounds.Width / (float)clientBounds.Height;
            NearClip = 0.1f;
            FarClip = 2000.0f;
            FOV = MathHelper.PiOver4;

            View = Matrix.CreateLookAt(Position, Target, Vector3.Up);
            Projection = Matrix.CreatePerspectiveFieldOfView(FOV, aspectRatio, NearClip, FarClip);
            World = Matrix.CreateTranslation(Position);
        }

        public override void Update(GameTime gameTime)
        {
            World = Matrix.CreateTranslation(Position);
            View = Matrix.CreateLookAt(Position, Target, Vector3.Up);
            Projection = Matrix.CreatePerspectiveFieldOfView(FOV, aspectRatio, NearClip, FarClip);

            
            base.Update(gameTime);
        }

        public void RotateLeft()
        { 
        
        }

        public void RotateRight()
        { 
        
        }

        public void RotateUp()
        { 
        
        }

        public void RotateDown()
        { 
        
        }

        public void PanLeft()
        { 
        
        }

        public void PanRight()
        { 
        
        }

        public void PanUp()
        { 
        
        }

        public void PanDown()
        { 
        
        }

    }
}
